VERSION 5.00
Begin VB.UserControl SCBox 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   ClientHeight    =   1455
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2505
   ClipControls    =   0   'False
   ControlContainer=   -1  'True
   ScaleHeight     =   1455
   ScaleWidth      =   2505
End
Attribute VB_Name = "SCBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Const stdCShOut = &H8000000F
Const stdCShIn = &H0
Const stdShDepth = 7
Const stdShBlur = 1
Const stdShStyle = 0
Const stdBoxStyle = 0
Const stdBoxDist = 7
Const stdCBoxIn = &H8000000C
Const stdCBoxOut = &HFFFFFF
Const stdPosition = 0
Const stdBoxDepth = 3
Const stdBoxApp = 0

Const cFactor = 0.5
Const cDark = &H80000015
Const cGrayDark = &H80000010
Const cGrayMid = &H80000016
Const cGrayLight = &H80000014

Public Enum BoxPosEnum
    [TopLeft] = 0
    [TopRight] = 1
    [BottomLeft] = 2
    [BottomRight] = 3
End Enum

Public Enum BoxStyleEnum
    [NoBox] = 0
    [BoxAngleRounded] = 1
    [BoxAngleStraight] = 2
    [BoxCylinderVertical] = 3
    [BoxCylinderHorizontal] = 4
    [GradientHorizontal] = 5
    [GradientVertical] = 6
End Enum

Public Enum BoxAppearEnum
    [Flat] = 0
    [Inset] = 1
    [Raised] = 2
End Enum

Public Enum AngleEnum
    [AngleRounded] = 0
    [AngleStraight] = 1
End Enum

Private stoCShOut As OLE_COLOR
Private stoCShIn As OLE_COLOR
Private stoShDepth  As Integer
Private stoShBlur As Integer
Private stoShStyle As AngleEnum
Private stoBoxStyle As BoxStyleEnum
Private stoBoxDist As Integer
Private stoCBoxIn As OLE_COLOR
Private stoCBoxOut As OLE_COLOR
Private stoPosition As BoxPosEnum
Private stoBoxDepth As Integer
Private stoBoxApp As BoxAppearEnum

Private giStepRed As Integer
Private giStepGreen As Integer
Private giStepBlue As Integer

Private giStartRed As Integer
Private giStartGreen As Integer
Private giStartBlue As Integer

Private Declare Function TranslateColor Lib "olepro32.dll" Alias "OleTranslateColor" (ByVal clr As OLE_COLOR, ByVal palet As Long, col As Long) As Long

Public Event Click()
Public Event DblClick()
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

Private Sub UserControl_Click()
    RaiseEvent Click
    DoEvents
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
    DoEvents
End Sub

Private Sub UserControl_InitProperties()
    stoCShOut = stdCShOut
    stoCShIn = stdCShIn
    stoShDepth = stdShDepth
    stoShBlur = stdShBlur
    stoShStyle = stdShStyle
    stoBoxStyle = stdBoxStyle
    stoBoxDist = stdBoxDist
    stoCBoxIn = stdCBoxIn
    stoCBoxOut = stdCBoxOut
    stoPosition = stdPosition
    stoBoxDepth = stdBoxDepth
    stoBoxApp = stdBoxApp
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseDown(Button, Shift, x, y)
    DoEvents
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseMove(Button, Shift, x, y)
    DoEvents
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseUp(Button, Shift, x, y)
    DoEvents
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    stoCShOut = PropBag.ReadProperty("CShadeOuter", stdCShOut)
    stoCShIn = PropBag.ReadProperty("CShadeInner", stdCShIn)
    stoShDepth = PropBag.ReadProperty("ShadeDepth", stdShDepth)
    stoShBlur = PropBag.ReadProperty("ShadeBlur", stdShBlur)
    stoShStyle = PropBag.ReadProperty("ShadeStyle", stdShStyle)
    stoBoxStyle = PropBag.ReadProperty("BoxStyle", stdBoxStyle)
    stoBoxDist = PropBag.ReadProperty("BoxDistance", stdBoxDist)
    stoCBoxIn = PropBag.ReadProperty("CBoxInner", stdCBoxIn)
    stoCBoxOut = PropBag.ReadProperty("CBoxOuter", stdCBoxOut)
    stoPosition = PropBag.ReadProperty("BoxPosition", stdPosition)
    stoBoxDepth = PropBag.ReadProperty("BoxDepth", stdBoxDepth)
    stoBoxApp = PropBag.ReadProperty("BoxAppearance", stdBoxApp)
    
    PaintControl
End Sub

Private Sub UserControl_Resize()
    PaintControl
End Sub

Private Sub UserControl_Show()
    PaintControl
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "CShadeOuter", stoCShOut, stdCShOut
    PropBag.WriteProperty "CShadeInner", stoCShIn, stdCShIn
    PropBag.WriteProperty "ShadeDepth", stoShDepth, stdShDepth
    PropBag.WriteProperty "ShadeBlur", stoShBlur, stdShBlur
    PropBag.WriteProperty "ShadeStyle", stoShStyle, stdShStyle
    PropBag.WriteProperty "BoxStyle", stoBoxStyle, stdBoxStyle
    PropBag.WriteProperty "BoxDistance", stoBoxDist, stdBoxDist
    PropBag.WriteProperty "CBoxInner", stoCBoxIn, stdCBoxIn
    PropBag.WriteProperty "CBoxOuter", stoCBoxOut, stdCBoxOut
    PropBag.WriteProperty "BoxPosition", stoPosition, stdPosition
    PropBag.WriteProperty "BoxDepth", stoBoxDepth, stdBoxDepth
    PropBag.WriteProperty "BoxAppearance", stoBoxApp, stdBoxApp
End Sub



'
' ---- Properties -----------------------------------
'

Public Property Get BoxAppearance() As BoxAppearEnum
Attribute BoxAppearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BoxAppearance = stoBoxApp
End Property

Public Property Let BoxAppearance(ByVal NewValue As BoxAppearEnum)
    If stoBoxApp <> NewValue Then
        stoBoxApp = NewValue
        PaintControl
        PropertyChanged "BoxAppearance"
    End If
End Property

Public Property Get BoxPosition() As BoxPosEnum
Attribute BoxPosition.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BoxPosition = stoPosition
End Property

Public Property Let BoxPosition(ByVal NewValue As BoxPosEnum)
    If stoPosition <> NewValue Then
        stoPosition = NewValue
        PaintControl
        PropertyChanged "BoxPosition"
    End If
End Property

Public Property Get BoxStyle() As BoxStyleEnum
Attribute BoxStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BoxStyle = stoBoxStyle
End Property

Public Property Let BoxStyle(ByVal NewValue As BoxStyleEnum)
    If stoBoxStyle <> NewValue Then
        stoBoxStyle = NewValue
        PaintControl
        PropertyChanged "BoxStyle"
    End If
End Property

Public Property Get BoxDistance() As Integer
Attribute BoxDistance.VB_ProcData.VB_Invoke_Property = "prpSCBox"
    BoxDistance = stoBoxDist
End Property

Public Property Let BoxDistance(ByVal NewValue As Integer)
    stoBoxDist = NewValue
    PaintControl
End Property

Public Property Get CShadeInner() As OLE_COLOR
Attribute CShadeInner.VB_ProcData.VB_Invoke_Property = ";Appearance"
    CShadeInner = stoCShIn
End Property

Public Property Let CShadeInner(ByVal NewValue As OLE_COLOR)
    stoCShIn = NewValue
    PaintControl
End Property

Public Property Get CShadeOuter() As OLE_COLOR
Attribute CShadeOuter.VB_ProcData.VB_Invoke_Property = ";Appearance"
    CShadeOuter = stoCShOut
End Property

Public Property Let CShadeOuter(ByVal NewValue As OLE_COLOR)
    stoCShOut = NewValue
    PaintControl
End Property

Public Property Get CBoxInner() As OLE_COLOR
Attribute CBoxInner.VB_ProcData.VB_Invoke_Property = ";Appearance"
    CBoxInner = stoCBoxIn
End Property

Public Property Let CBoxInner(ByVal NewValue As OLE_COLOR)
    stoCBoxIn = NewValue
    PaintControl
End Property

Public Property Get CBoxOuter() As OLE_COLOR
Attribute CBoxOuter.VB_ProcData.VB_Invoke_Property = ";Appearance"
    CBoxOuter = stoCBoxOut
End Property

Public Property Let CBoxOuter(ByVal NewValue As OLE_COLOR)
    stoCBoxOut = NewValue
    PaintControl
End Property

Public Property Get BoxDepth() As Integer
Attribute BoxDepth.VB_ProcData.VB_Invoke_Property = "prpSCBox;Appearance"
    BoxDepth = stoBoxDepth
End Property

Public Property Let BoxDepth(ByVal NewValue As Integer)
    If stoBoxDepth <> NewValue Then
        stoBoxDepth = NewValue
        PaintControl
        PropertyChanged "BoxDepth"
    End If
End Property

Public Property Get ShadeDepth() As Integer
Attribute ShadeDepth.VB_ProcData.VB_Invoke_Property = "prpSCBox"
    ShadeDepth = stoShDepth
End Property

Public Property Let ShadeDepth(ByVal NewValue As Integer)
    stoShDepth = NewValue
    If stoShDepth = 0 Then stoShDepth = 1
    PaintControl
End Property

Public Property Get ShadeBlur() As Integer
Attribute ShadeBlur.VB_ProcData.VB_Invoke_Property = "prpSCBox"
    ShadeBlur = stoShBlur
End Property

Public Property Let ShadeBlur(ByVal NewValue As Integer)
    If stoShBlur <> NewValue Then
        stoShBlur = NewValue
        PaintControl
        PropertyChanged "ShadeBlur"
    End If
End Property

Public Property Get ShadeStyle() As AngleEnum
Attribute ShadeStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
    ShadeStyle = stoShStyle
End Property

Public Property Let ShadeStyle(ByVal NewValue As AngleEnum)
    If stoShStyle <> NewValue Then
        stoShStyle = NewValue
        PaintControl
        PropertyChanged "ShadeStyle"
    End If
End Property



'
' ---- Methods -------------------------------------
'

Public Sub Refresh()

    PaintControl
End Sub



'
' ---- Procedures -----------------------------------
'

Private Sub pDrawAnglesRound(iDepth As Integer, iBoxDist As Integer)
    Dim i, iFirst As Integer
    Dim iH, iW As Integer
    Dim iHeight As Integer
    Dim iWidth As Integer
    Dim lColor As Long
    
    iHeight = ScaleHeight - iBoxDist
    iWidth = ScaleWidth - iBoxDist
    FillStyle = vbSolid
    
    iFirst = IIf(stoBoxApp > [Flat], 2, 0)

    For i = iFirst To iDepth - 1
        If i >= iWidth Then Exit For
        If i >= iHeight Then Exit For
        
        lColor = lgetColor(i + 1)
        FillColor = lColor
            
        iH = iHeight - iDepth
        iW = iWidth - iDepth
        ' top-left angle
        Circle (iDepth, iDepth), iDepth - i, lColor, -1.57, -3.14
        ' bottom-left angle
        Circle (iDepth, iH - 1), iDepth - i, lColor, -3.14, -4.71
        ' bottom-right angle
        Circle (iW - 1, iH - 1), iDepth - i, lColor, -4.71, -6.28
        ' top-right angle
        Circle (iW - 1, iDepth), iDepth - i, lColor, -6.28, -1.57

        Line (i, iDepth)-Step(0, iH - iDepth), lColor
        Line (iDepth, iHeight - i - 1)-Step(iW - iDepth, 0), lColor
        Line (iWidth - i - 1, iH)-Step(0, -(iH - iDepth)), lColor
        Line (iW, i)-Step(-(iW - iDepth), 0), lColor
    Next
    For i = iDepth To iHeight - iDepth
        Line (iDepth, i)-Step(iWidth + 1 - iDepth * 2, 0), lColor
    Next
End Sub

Private Sub pDrawAnglesSquare(iDepth As Integer, iBoxDist As Integer)
    Dim i As Integer
    Dim iH, iW As Integer
    Dim iHeight As Integer
    Dim iWidth As Integer
    Dim lColor As Long
    
    iHeight = ScaleHeight - iBoxDist
    iWidth = ScaleWidth - iBoxDist
    
    For i = 0 To iDepth - 1
        If i >= iWidth Then Exit For
        If i >= iHeight Then Exit For

        lColor = lgetColor(i + 1)
        
        iH = iHeight - i * 2
        iW = iWidth - i * 2
        CurrentX = i
        CurrentY = i
        Line -Step(0, iH - 1), lColor
        Line -Step(iW - 1, 0), lColor
        Line -Step(0, -(iH - 1)), lColor
        Line -Step(-(iW - 1), 0), lColor
    Next
    For i = iDepth To iHeight - iDepth
        Line (iDepth, i)-Step(iWidth - iDepth * 2, 0), lColor
    Next
End Sub

Private Sub pDrawBorder(iDepth As Integer)
    Dim i As Integer
    Dim iH, iW As Integer
    Dim iHeight As Integer
    Dim iWidth As Integer
    Dim lColor1, lColor2 As Long
    
    If stoBoxApp = Flat Then Exit Sub
    
    iHeight = ScaleHeight - stoBoxDist
    iWidth = ScaleWidth - stoBoxDist
    FillStyle = vbSolid
    
    For i = 0 To 1
        If i = 0 Then
            If stoBoxApp = Inset Then
                lColor1 = cGrayDark
                lColor2 = cGrayLight
            Else
                lColor1 = cGrayMid
                lColor2 = cDark
            End If
        Else
            If stoBoxApp = Inset Then
                lColor1 = cDark
                lColor2 = cGrayMid
            Else
                lColor1 = cGrayLight
                lColor2 = cGrayDark
            End If
        End If

        If stoBoxStyle = [BoxAngleRounded] Then
            
            iH = iHeight - iDepth
            iW = iWidth - iDepth
            ' top-left angle
            FillColor = lColor1
            Circle (iDepth, iDepth), iDepth - i, lColor1, -1.57, -3.14
            ' bottom-left angle
            Circle (iDepth, iH - 1), iDepth - i, lColor1, -3.14, -4.71
            ' bottom-right angle
            FillColor = lColor2
            Circle (iW - 1, iH - 1), iDepth - i, lColor2, -4.71, -6.28
            ' top-right angle
            FillColor = lColor1
            Circle (iW - 1, iDepth), iDepth - i, lColor1, -6.28, -1.57

            Line (i, iDepth)-Step(0, iH - iDepth), lColor1
            Line (iDepth, iHeight - i - 1)-Step(iW - iDepth, 0), lColor2
            Line (iWidth - i - 1, iH)-Step(0, -(iH - iDepth)), lColor2
            Line (iW, i)-Step(-(iW - iDepth), 0), lColor1
        
        Else
            iH = iHeight - i * 2
            iW = iWidth - i * 2
            CurrentX = i
            CurrentY = i
            Line -Step(0, iH), lColor1
            Line -Step(iW, 0), lColor2
            Line -Step(0, -(iH)), lColor2
            Line -Step(-(iW), 0), lColor1
        End If
    Next
End Sub

Private Sub pDrawCylinder(iDepth As Integer, iEffect As BoxStyleEnum)
    Dim i As Integer
    Dim iHeight As Integer
    Dim iWidth As Integer
    Dim lColor As Long
    
    iHeight = ScaleHeight - stoBoxDist
    iWidth = ScaleWidth - stoBoxDist
    
    For i = 0 To iDepth - 1

        lColor = lgetColor(i + 1)
        
        Select Case iEffect
        Case [BoxCylinderVertical], [GradientVertical]
            If i >= iWidth Then Exit For
            
            Line (i, 0)-Step(0, iHeight), lColor
            If iEffect = 3 Then
                Line (iWidth - i - 1, 0)-Step(0, iHeight), lColor
            End If
        Case [BoxCylinderHorizontal], [GradientHorizontal]
            If i >= iHeight Then Exit For
            
            Line (0, i)-Step(iWidth, 0), lColor
            If iEffect = 4 Then
                Line (0, iHeight - i - 1)-Step(iWidth, 0), lColor
            End If
        End Select
    Next

    Select Case iEffect
    Case [BoxCylinderVertical]
        For i = iDepth To iWidth - iDepth
            Line (i, 0)-Step(0, iHeight), lColor
        Next
    Case [BoxCylinderHorizontal]
        For i = iDepth To iHeight - iDepth
            Line (0, i)-Step(iWidth, 0), lColor
        Next
    Case [GradientVertical]
        For i = iDepth To iWidth
            Line (i, 0)-Step(0, iHeight), lColor
        Next
    Case [GradientHorizontal]
        For i = iDepth To iHeight
            Line (0, i)-Step(iWidth, 0), lColor
        Next
    End Select
End Sub

Private Sub pRGBColor(oleColorExt As OLE_COLOR, oleColorInt As OLE_COLOR, _
                        iDepth As Integer, iFactor As Integer)
    Dim sngFact As Single
    Dim lColorExt As Long
    Dim lColorInt As Long
    Dim extR, extG, extB As Integer
    Dim intR, intG, intB As Integer
    'define the starting color of the gradient
    'and steps to the ending color
    
    lColorExt = 0
    lColorInt = 0
    TranslateColor oleColorExt, 0, lColorExt
    TranslateColor oleColorInt, 0, lColorInt
    
    extR = lColorExt And &HFF
    extG = (lColorExt \ 256) And &HFF
    extB = (lColorExt \ 65536) And &HFF
    intR = lColorInt And &HFF
    intG = (lColorInt \ 256) And &HFF
    intB = (lColorInt \ 65536) And &HFF
    
    sngFact = IIf(iDepth = 0, 1, CSng(iDepth) * (1 + iFactor * 0.2))

    giStepRed = (intR - extR) / sngFact
    giStepGreen = (intG - extG) / sngFact
    giStepBlue = (intB - extB) / sngFact
    
    giStartRed = extR
    giStartGreen = extG
    giStartBlue = extB
End Sub

Private Function lgetColor(ByVal Index As Integer) As Long
    Dim xRed, xGreen, xBlue As Long

    xRed = giStartRed + giStepRed * (Index)
    xGreen = giStartGreen + giStepGreen * (Index)
    xBlue = giStartBlue + giStepBlue * (Index)
    
    If xRed > 255 Then xRed = 255
    If xRed < 0 Then xRed = 0
    
    If xGreen > 255 Then xGreen = 255
    If xGreen < 0 Then xGreen = 0
    
    If xBlue > 255 Then xBlue = 255
    If xBlue < 0 Then xBlue = 0
    
    lgetColor = (CLng(xBlue) * 256 + xGreen) * 256 + xRed
End Function

Private Sub PaintControl()
    
    Cls
    ScaleMode = vbPixels
    BackColor = stoCShOut
    
    ' draw shadow
    pRGBColor stoCShOut, stoCShIn, stoShDepth, stoShBlur
    Select Case stoPosition
    Case [TopLeft]
        ScaleTop = CInt(-stoBoxDist * cFactor)
        ScaleLeft = CInt(-stoBoxDist * cFactor)
    Case [TopRight]
        ScaleTop = CInt(-stoBoxDist * cFactor)
        ScaleLeft = 0
    Case [BottomLeft]
        ScaleTop = 0
        ScaleLeft = CInt(-stoBoxDist * cFactor)
    Case [BottomRight]
        ScaleTop = 0
        ScaleLeft = 0
    End Select
    
    Select Case stoShStyle
    Case [AngleRounded]
        pDrawAnglesRound stoShDepth, CInt(stoBoxDist * cFactor)
    Case [AngleStraight]
        pDrawAnglesSquare stoShDepth, CInt(stoBoxDist * cFactor)
    End Select
    
    ' draw box
    pRGBColor stoCBoxOut, stoCBoxIn, stoBoxDepth, 0
    Select Case stoPosition
    Case [TopLeft]
        ScaleTop = 0
        ScaleLeft = 0
    Case [TopRight]
        ScaleTop = 0
        ScaleLeft = -stoBoxDist
    Case [BottomLeft]
        ScaleTop = -stoBoxDist
        ScaleLeft = 0
    Case [BottomRight]
        ScaleTop = -stoBoxDist
        ScaleLeft = -stoBoxDist
    End Select

    Select Case stoBoxStyle
        Case [NoBox]
        
        Case [BoxAngleRounded]
            pDrawBorder stoBoxDepth
            pDrawAnglesRound stoBoxDepth, stoBoxDist
        Case [BoxAngleStraight]
            pDrawAnglesSquare stoBoxDepth, stoBoxDist
            pDrawBorder stoBoxDepth
        Case Else
            pDrawCylinder stoBoxDepth, stoBoxStyle
            pDrawBorder stoBoxDepth
    End Select
    
    ScaleMode = vbTwips
End Sub
